// Friio USB DTV Adapterp
// ݂BonDriverɏϑĂ̂ŁA񏈗v̓_~[A
// CyAPIgă_CNgɂ̂s\ł͂ȂB

#include "StdAfx.h"
#include "DTV_Friio.h"

CDTV_Friio::CDTV_Friio() : CDTV_Base()
{
	m_hLib=NULL;
	m_pBonDrv=NULL;
	m_bOpen=FALSE;
	m_iChannel = -1;
}

CDTV_Friio::~CDTV_Friio(void)
{
	if(IsInitialized()) Release();
}


BOOL CDTV_Friio::Initialize(char *szInitString,HWND hWnd,GUID *pGuid)
{
	if(IsInitialized()) return FALSE;

	m_hLib=LoadLibrary(szInitString);
	if(!m_hLib) return FALSE;

	PFCREATEBONDRIVER *pf=(PFCREATEBONDRIVER*)GetProcAddress(m_hLib,"CreateBonDriver");
	if(!pf)
	{
		FreeLibrary(m_hLib);
		m_hLib=NULL;
		return FALSE;
	}
	m_pBonDrv=pf();
	if(!m_pBonDrv)
	{
		FreeLibrary(m_hLib);
		m_hLib=NULL;
		return FALSE;
	}

	// `l inifile w
//	GetChannelNameFromIni();

	return TRUE;
}

void CDTV_Friio::Release()
{
	DisConnect();
	if(m_pBonDrv)
	{
		m_pBonDrv->Release();
		m_pBonDrv=NULL;
	}
	if(m_hLib)
	{
		FreeLibrary(m_hLib);
		m_hLib=NULL;
	}
}

BOOL CDTV_Friio::IsInitialized()
{
	return m_hLib?TRUE:FALSE;
}

DWORD CDTV_Friio::GetExtFunction()
{
	/* ǂ炩ɂ邱 */
	return DTV_EXTFUNC_CHSEL;
//	return DTV_EXTFUNC_CHSTR;
}

DWORD CDTV_Friio::GetDeviceCount()
{
	if(!IsInitialized()) return 0;
	return 1;
}

BOOL CDTV_Friio::GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen)
{
	if(!IsInitialized()) return FALSE;
	lstrcpyn(lpszDevName,"Friio(ISDB-T)",iBufLen);
	return TRUE;
}

DWORD CDTV_Friio::GetUsbEndpointCount(int iDevNo)
{
	if(!IsInitialized()) return 0;
	return 2;
}

// _~[(Ƃ肠AddressAttributeȊOQƂĂȂ̂)
BOOL CDTV_Friio::GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo)
{
	if(!IsInitialized()) return FALSE;

	pUsbEpInfo->DscLen=0x07;
	pUsbEpInfo->DscType=0x05;
	pUsbEpInfo->Address=(iUsbEpNo==0?0x81:0x02);
	pUsbEpInfo->Attributes=0x02;
	pUsbEpInfo->MaxPktSize=0x200;
	pUsbEpInfo->PktsPerFrame=0xbaad;
	pUsbEpInfo->Interval=0x00;
	pUsbEpInfo->TimeOut=0x2710;
	pUsbEpInfo->UsbdStatus=0xbaadf00d;
	pUsbEpInfo->NtStatus=0xbaadf00d;

	return TRUE;
}

BOOL CDTV_Friio::IsEndpointEffective(int iDevNo,int iUsbEpAddr)
{
	if(!IsInitialized()) return FALSE;
	return TRUE;
}

BOOL CDTV_Friio::Connect(int iDevNo,int iInEpAddr,int iOutEpAddr)
{
	if(!IsInitialized()) return FALSE;
	if(IsConnect()) return FALSE;

	struct DTV_ThreadParam *pReq=NULL;
	struct DTV_ThreadParam *pRes=NULL;
	try
	{
		pReq=new struct DTV_ThreadParam;
		if(!pReq) throw 101;
		ZeroMemory(pReq,sizeof(struct DTV_ThreadParam));
		pReq->pClassPtr=this;
		m_stThread.hExitEvent=pReq->hExitEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
		if(!m_stThread.hExitEvent) throw 102;

		m_pBonDrv->OpenTuner();
		m_bOpen=TRUE;

		m_stThread.stRequest.hThread=CreateThread(NULL,0,XferRequestThreadEntry,pReq,CREATE_SUSPENDED,&m_stThread.stRequest.dwThreadID);
		if(!m_stThread.stRequest.hThread)
		{
			throw 501;
		}

		::SetThreadPriority(m_stThread.stRequest.hThread,m_iPriority_Request);

		// Jn
		ResumeThread(m_stThread.stRequest.hThread);
	}
	catch(int err_code)
	{
		DTV_CATCH_INT_ERROR_CODE(err_code);
	}
	return TRUE;
}

void CDTV_Friio::DisConnect()
{
	if(IsConnect())
	{
		SetEvent(m_stThread.hExitEvent);
		if(WaitForSingleObject(m_stThread.hExitEvent,10*1000)!=WAIT_OBJECT_0)
		{
			// ^CAEgȂ̂ŋ~
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
		}
		DWORD dwExitCode;
		GetExitCodeThread(m_stThread.stRequest.hThread,&dwExitCode);

		m_pBonDrv->CloseTuner();
		m_bOpen=FALSE;
	}
}

BOOL CDTV_Friio::IsConnect()
{
	if(!IsInitialized()) return FALSE;
	return m_bOpen;
}

void CDTV_Friio::GetDeviceInfoText(char *lpszText,int iBufSize)
{
	if(IsConnect())
	{
		char buf[80];
		div_t d=div((int)((float)m_pBonDrv->GetSignalLevel()*100),100);
		wsprintf(buf,"C/N %d.%02ddB",d.quot,d.rem);
		lstrcpyn(lpszText,buf,iBufSize);
	} else {
		CDTV_Base::GetDeviceInfoText(lpszText,iBufSize);
	}
}

DWORD CDTV_Friio::XferRequestProc(struct DTV_ThreadParam *lpParameter)
{
	m_pBonDrv->PurgeTsStream();	
    // NGXg[v
	while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0)
	{
		DWORD dwWaitState;
		dwWaitState=m_pBonDrv->WaitTsStream(100);
		if(dwWaitState==WAIT_OBJECT_0)
		{
			BYTE *pTsData = NULL;
			DWORD dwRecvSize;
			DWORD dwRemain;
			do
			{
				if(m_pBonDrv->GetTsStream(&pTsData,&dwRecvSize,&dwRemain))
				{
					m_stTransferInfo.ui64RecvTotal+=dwRecvSize;
					DoDTVDataCallback(pTsData,dwRecvSize,m_stTransferInfo.ui64RecvTotal);
					m_stTransferInfo.dwSuccess++;
				}
			} while(dwRemain);
		} else if(dwWaitState!=WAIT_TIMEOUT) {
			m_stTransferInfo.dwFail++;
		}
		Sleep(1);
	}

	// I
	delete lpParameter;
	ExitThread(1);
	return 0;
}

DWORD CDTV_Friio::GetChannelCount()
{
	// `l inifile w
//	int size = m_channels.size();
//	if (size > 0) {
//		return size;
//	}

	return (62-13)+1;
}

int CDTV_Friio::GetChannelName(int iChIndex,char *lpszChName,int iBufSize)
{
	// `l inifile w
//	if (m_channels.size() > 0) {
//		struct ChannelData cd = m_channels[iChIndex];
//		lstrcpyn(lpszChName, cd.name, iBufSize);
//		return cd.index;
//	}

	if(GetChannelCount()<=(unsigned)iChIndex) return -1;
	char buf[40];
	wsprintf(buf,"nD Ch%2d",iChIndex+13);
	lstrcpyn(lpszChName,buf,iBufSize);
	return iChIndex+13;
}

BOOL CDTV_Friio::SetChannel(int iCh)
{
	if(!IsConnect()) return FALSE;
	m_iChannel = iCh;
	if(!m_pBonDrv->SetChannel((BYTE)iCh)) return FALSE;	
	return TRUE;
}

int CDTV_Friio::GetChannel()
{
	if(!IsConnect()) return -1;
	return m_iChannel;
}

BOOL CDTV_Friio::SetChannnelByString(char *lpszChStr)
{
	int ch = atoi(lpszChStr);
	if(ch<13||ch>62) return FALSE;
	return SetChannel(ch);
}